//===========================================================
//===========================================================



#include "debug.h"
#include "system_mcu_set.h"



void System_Function_Set(void)
{
	System_Gpio_Init();

    System_Time3_Set( 357 , 100 ); // 72MHZ 100DIV 2KHZ=500us 72000000/100/2000=360
	
	System_Adc_Set();
}




//==========================================================================
// HGPIOʼ  

//==========================================================================
/***************************************************************************
ע ע 


***************************************************************************/
//==========================================================================
void System_Gpio_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};

	// GPIOB ʱ ʹ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
	
	// LED 
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15 ;     // LED1 LED2 LED3
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	// IO KEY ©  
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 ;    	
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

	// IO_WAKE_CHARGE © 绽
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);	
	
	// INT_CUR       · ж 
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);		

	// ADC PB1    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

	// ˿ ʼƽ
    GPIO_ResetBits( GPIOB , GPIO_Pin_13 );                                  // LED3
    GPIO_ResetBits( GPIOB , GPIO_Pin_14 );                                  // LED2
    GPIO_ResetBits( GPIOB , GPIO_Pin_15 );                                  // LED1

	// GPIOA ʱ ʹ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	
	// OLED 
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_9 | GPIO_Pin_10 ;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	
	// OZ9350 WAKEUP 
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_1 ;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	// OZ9350 SCL SDA  
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4 | GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

	// GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4 | GPIO_Pin_5;
    // GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    // GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    // GPIO_Init(GPIOA, &GPIO_InitStructure);
	

	// PLOCK  ©
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	// IO_WAKE_WORK	©   
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	// ADC PA6  PA7    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

	// OLED  ˿ ʼƽ 
    GPIO_SetBits( GPIOA , GPIO_Pin_9 );                                     // OLED_SDA
    GPIO_SetBits( GPIOA , GPIO_Pin_10 );                                    // OLED_SCL

	// OZ9350  ˿  ʼƽ
    GPIO_SetBits( GPIOA , GPIO_Pin_4 );                                     // OZ9350 IIC_SDA
    GPIO_SetBits( GPIOA , GPIO_Pin_5 );                                     // OZ9350 IIC_SCL
	GPIO_SetBits( GPIOA , GPIO_Pin_1 );                                     // OZ9350 WAKE UP 
	
	GPIO_SetBits( GPIOA , GPIO_Pin_0 );                                   // PLOCK 
	



}



//==========================================================================
// timer3 ʼ  
// ʱģʽ жϿ  
//==========================================================================
/***************************************************************************

***************************************************************************/
//==========================================================================


void System_Time3_Set( unsigned int cycle, unsigned int psc )
{
	
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef 		 NVIC_InitStructure;	
	
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE); 		//ʹTIM3ʱ
	
	
    TIM_TimeBaseStructure.TIM_Period = cycle;   				//ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler = psc; 					//ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //TIMģʽϼģʽ
	
	TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);				//ָĲʼTIMxʱλ
	
	TIM_ITConfig(TIM3,TIM_IT_Update,ENABLE );			 		//ʹTIM3жϣж
	
    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;          	//TIM3ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0; 	//ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;        	//Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;           	//ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure); 						  	//ʼNVIC

    TIM_Cmd(TIM3, ENABLE);				 					  	//TIM3ʹ
	
}



void System_Adc_Set()
{
	// // ѯģʽ 
	// Sytem_Adc_Cycle_Set();
	
	// жģʽ 
	System_Adc_Isr_Mode_Set();
	System_Adc_Isr_Set();
	
	
}




//==========================================================================
//	ADC ʼ  
//	ѯ
//==========================================================================
/***************************************************************************
ͨ 

//PA6 OZ9350 VAO  AIN6
//PA7 INA199 CUR  AIN7
//PB1 TEMP   NTC  AIN9

Ϊ ǰGPIOѾú ˿ڵ GPIO_Mode_AIN  ģʽ

***************************************************************************/
//==========================================================================
void System_Adc_Cycle_Set()
{
    ADC_InitTypeDef ADC_InitStructure;
    // GPIO_InitTypeDef GPIO_InitStructure;

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_ADC1 , ENABLE ); //ʹGPIOAʱӺADC
	
    // RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_ADC1 , ENABLE ); //ʹGPIOAʱӺADC
    // GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    // GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    // GPIO_Init(GPIOA, &GPIO_InitStructure);

    RCC_ADCCLKConfig(RCC_PCLK2_Div6); //ADCʱӷƵΪ6Ƶ
    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;   //ADCΪģʽ
    ADC_InitStructure.ADC_ScanConvMode = DISABLE;        //ڵͨģʽִת
    ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;  //ڵģʽִת
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; //תⲿ
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right; //ADCҶ
    ADC_InitStructure.ADC_NbrOfChannel = 1;                //˳йתADCͨĿ
    ADC_Init(ADC1, &ADC_InitStructure);                    //ADC_InitStructureָĲʼADC1Ĵ

    ADC_Cmd(ADC1, ENABLE); //ʹADC1

    ADC_ResetCalibration(ADC1); //ADC1У׼Ĵ

    while(ADC_GetResetCalibrationStatus(ADC1)); //ȴλУ׼

    ADC_StartCalibration(ADC1); //ADУ׼

    while(ADC_GetCalibrationStatus(ADC1));      //ȴУ׼
	
}

//==========================================================================
//	ADC ȡ   
//
//==========================================================================
/***************************************************************************
 ת 

***************************************************************************/
//==========================================================================
unsigned int System_Adc_Start_Get( unsigned char ch_sel )
{
    ADC_RegularChannelConfig(ADC1, ch_sel, 1, ADC_SampleTime_239Cycles5 );//ΪѡADCͨеӦ鼰ʱ䡣

    ADC_SoftwareStartConvCmd(ADC1, ENABLE); //ʹADC1ת

    while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC )); //ȴת

    return ADC_GetConversionValue(ADC1); //سͨһADC1ת
}


//==========================================================================
//  ADC ʼ
//  ж 
//==========================================================================
/***************************************************************************
ͨ

//PA6 OZ9350 VAO  AIN6
//PA7 INA199 CUR  AIN7
//PB1 TEMP   NTC  AIN9

Ϊ ǰGPIOѾú ˿ڵ GPIO_Mode_AIN  ģʽ

***************************************************************************/
//==========================================================================
void System_Adc_Isr_Mode_Set()
{
    ADC_InitTypeDef  ADC_InitStructure;


    RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 , ENABLE ); //ʹGPIOAʱӺADC

    //ADC ģʽ
    RCC_ADCCLKConfig(RCC_PCLK2_Div6);  // ADCʱΪPCLK26Ƶ12MHz

    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent; //ֻʹһADCڶģʽ
    ADC_InitStructure.ADC_ScanConvMode = DISABLE ;     //ֹɨģʽͨҪͨҪ
    ADC_InitStructure.ADC_ContinuousConvMode = DISABLE; //תģʽ
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; //ⲿת
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;              //תҶ
    ADC_InitStructure.ADC_NbrOfChannel = 1;            //תͨ1
    ADC_Init(ADC1, &ADC_InitStructure); //ʼADC

    ADC_Cmd(ADC1, ENABLE); //ADCʼת

    ADC_ResetCalibration(ADC1); //ʼADCУ׼Ĵ

    while(ADC_GetResetCalibrationStatus(ADC1)); //ȴУ׼Ĵʼ

    ADC_StartCalibration(ADC1); //ADCʼУ׼

    while(ADC_GetCalibrationStatus(ADC1));      //ȴУ׼

}


//==========================================================================
//  ADC ж 
//  ж 
//==========================================================================
/***************************************************************************
void ADC_NVIC_Config(void)
***************************************************************************/
//==========================================================================
void System_Adc_Isr_Set(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;
  // ȼ
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
  // жȼ
  NVIC_InitStructure.NVIC_IRQChannel = ADC_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}



