//===========================================================
//	FMD64F0A5
// â΢ 
// ROM        -        10k  -  14Bit 
// RAM        -          1k   -   8Bit
// EEPROM  -  128byte  -   8Bit 
// HIRC		  - 16MHZ
// 1T/2T/4T/
// 
//	汾עͣ 
// 
//===========================================================



#include  "debug.h"
#include  "system_mcu_set.h"

#include  "function_project.h"
#include  "function_ssd1306.h"
#include  "function_screen.h"
#include  "function_oz9350.h"

/*****************************************************************************************
*  ṹ 
*  λ  
*****************************************************************************************/
struct TIME 			  		    TMB;
struct MANAGE 						MA;
struct WORKST 						WORK;

unsigned char Test_Flag;

//===========================================================
//Funtion name time_base
//parameters
//returned value
// ע 
// ܶĶʱʱڸúۼ
//===========================================================
void Time_Base()
{
unsigned char time_effect_flag = 0;


	#if(  TIMER_BASE_UNIT_TIME_SELECT == TIMER_100US_SEL ) 
		// ʱ䶯 
		if( TMB.us_100ct >= 10 )
		{
			TMB.us_100ct = 0;
			TMB.ms_1ct++;
			time_effect_flag |= 0x01;
			// TMB - 1MS 
		}		
	
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_125US_SEL )
	
    
		// ʱ䶯 
		if( TMB.us_125ct >= 8 )
		{
			TMB.us_125ct = 0;
			TMB.ms_1ct++;
			time_effect_flag |= 0x01;
			// TMB - 1MS 
		}	
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_200US_SEL )
	
    
		// ʱ䶯 
		if( TMB.us_200ct >= 5 )
		{
			TMB.us_200ct = 0;
			TMB.ms_1ct++;
			time_effect_flag |= 0x01;
			// TMB - 1MS 
		}			
		
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_250US_SEL )
	
    
		// ʱ䶯 
		if( TMB.us_250ct >= 4 )
		{
			TMB.us_250ct = 0;
			TMB.ms_1ct++;
			time_effect_flag |= 0x01;
			// TMB - 1MS 
		}			
		
        
	#elif(  TIMER_BASE_UNIT_TIME_SELECT == TIMER_500US_SEL ) 
    
		// ʱ䶯 
		if( TMB.us_500ct >= 2 )
		{
			TMB.us_500ct = 0;
			TMB.ms_1ct++;
			time_effect_flag |= 0x01;
			// TMB - 1MS 
		}	
		
		
	#endif	

    
	if( TMB.ms_1ct >= 10 )
	{
		TMB.ms_1ct = 0;
		TMB.ms_10ct++;
		time_effect_flag |= 0x02;
		// TMB - 10MS 

		if( TMB.ms_10ct >= 10 )
		{
			TMB.ms_10ct = 0;
			TMB.ms_100ct++;
			time_effect_flag |= 0x04;
			// TMB - 100MS 
					
			
			if( TMB.ms_100ct >= 10 )
			{
				TMB.ms_100ct = 0;
				time_effect_flag |= 0x08;
				// TMB - 1S 

			}
		}
	}
	
	// ʱ 
	if( time_effect_flag & 0x01 )
    {
        // 1ms 


    }
	if( time_effect_flag & 0x02 )
    {
		// 10ms
		Oled_Time_Add();
		
    }
	if( time_effect_flag & 0x04 )
    {
		// 100MS
		
		 if( WORK.Test_Gpio )
		 {
			 WORK.Test_Gpio = 0;
			 GPIO_SetBits( GPIOB , GPIO_Pin_13 );
		 }
		 else
		 {
			 WORK.Test_Gpio = 1;
			
			 GPIO_ResetBits( GPIOB , GPIO_Pin_13 );
		 }
		
		// WORK.Test_Adc_Cycle_Time++;
		
		// if( Test_Flag == 0 )
	    // {
	        // Test_Flag = 1;
			// OZ9350_SDA_HIGHT;
			// OZ9350_SCK_HIGHT;
			
	    // }
		// else
		// {
			// Test_Flag = 0;
			// OZ9350_SDA_LOW;
			// OZ9350_SCK_LOW;
		// }
		
		
    }
	if( time_effect_flag & 0x08 )
    {
        // 1s
	    if( Test_Flag == 0 )
	    {
	        Test_Flag = 1;

	        OZ9350_Init();
	    }
		else
		{
			Test_Flag = 0;
		}
    }	
	
}

//===========================================================
//Funtion name λʱۼ 
//parameters
//returned value
// ע 
// ܶĶʱʱڸúۼ
//===========================================================
void Time_Base_Add()
{
	#if( TIMER_BASE_UNIT_TIME_SELECT == TIMER_100US_SEL )
    
		TMB.us_100ct++;
	
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_125US_SEL )
    
		TMB.us_125ct++;
		
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_200US_SEL )
    
		TMB.us_200ct++;		
		
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_250US_SEL )
    
		TMB.us_250ct++;				
    
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_500US_SEL ) 
    
		TMB.us_500ct++;
        
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_1MS_SEL ) 
    
		TMB.ms_1ct++;
		
	#elif( TIMER_BASE_UNIT_TIME_SELECT == TIMER_2MS_SEL ) 
    
		TMB.ms_1ct+=2;
        
	#endif
}






//===========================================================
//Funtion name task_manage
//parameters
//returned value
//===========================================================
void Task_Manage()
{
	// л 

	// ִ
	switch( MA.Task_Posistion )
	{

		
		case 0:

			Time_Base();						//  ܳ10ms

			TA_TASK_NEXT;
		
			break;
			
		case 1:
			
			Oled_Disp_Process();
			
			TA_TASK_NEXT;	
		
			break;
			
		case 2:
		
			Power_Lock_Fun();
			
			TA_TASK_NEXT;
		
			break;
			
		case 3:
		
		
			TA_TASK_NEXT;
			
			break;			
			
		case 4:
		
			
			TA_TASK_RES;
			
			break;							
			
		default:
			TA_TASK_RES;
			break;
		
	}

}

//===========================================================
//Funtion name  Task_manage_Data_Init
//parameters
//returned value
//  ݳʼ 
// 
//===========================================================
void Task_Manage_Data_Init()
{
	TA_TASK_RES;
		
		
	WORK.Test_Gpio = 0;
	
	Oled_Init();
	Oled_Open_Set();
	
	WORK.Plock_Sta = WORK_PLOCK_ENABLE;
	
	
	WORK.Test_Adc_Cycle_Time     = 0;
	
	WORK.Test_Adc_Data_Step_A 	 = 0;
	WORK.Test_Adc_Data_Rank_A[ 0 ] = 0;
	WORK.Test_Adc_Data_Rank_A[ 1 ] = 0;
	WORK.Test_Adc_Data_Rank_A[ 2 ] = 0;
	WORK.Test_Adc_Data_Rank_A[ 3 ] = 0;

	WORK.Test_Adc_Data_Step_B 	 = 0;
	WORK.Test_Adc_Data_Rank_B[ 0 ] = 0;
	WORK.Test_Adc_Data_Rank_B[ 1 ] = 0;
	WORK.Test_Adc_Data_Rank_B[ 2 ] = 0;
	WORK.Test_Adc_Data_Rank_B[ 3 ] = 0;

	WORK.Test_Adc_Data_Step_C 	 = 0;
	WORK.Test_Adc_Data_Rank_C[ 0 ] = 0;
	WORK.Test_Adc_Data_Rank_C[ 1 ] = 0;
	WORK.Test_Adc_Data_Rank_C[ 2 ] = 0;
	WORK.Test_Adc_Data_Rank_C[ 3 ] = 0;
	
	WORK.Test_Adc_Data_Step 	 = 0;
	WORK.Test_Adc_Buff_Cnt       = 0;
	WORK.Test_Adc_Data_Rank[ 0 ] = 0;
	WORK.Test_Adc_Data_Rank[ 1 ] = 0;
	WORK.Test_Adc_Data_Rank[ 2 ] = 0;

	Test_Flag = 0;
	
	
	
}
//===========================================================
//Funtion name  
//parameters
//returned value
//    
// 
//===========================================================
void Power_Lock_Fun()
{
	if( WORK.Plock_Sta == WORK_PLOCK_ENABLE )
	{
		GPIO_ResetBits( GPIOA , GPIO_Pin_0 ); 
	}
	else
	{
		GPIO_SetBits( GPIOA , GPIO_Pin_0 ); 
	}
	
}



//===========================================================
//Funtion name  Adc_Isr_Start_Fun
//parameters
//returned value
//  ʱж  ADCת 
// 
//===========================================================
void Adc_Isr_Start_Fun()
{	
	//GPIO_SetBits( GPIOB , GPIO_Pin_13 );

	WORK.Test_Adc_Data_Step = 0;
	
    ADC_RegularChannelConfig(ADC1, ADC_Channel_6, 1,ADC_SampleTime_55Cycles5); // ADCͨת˳Ͳʱ

    ADC_ITConfig(ADC1, ADC_IT_EOC, ENABLE);  //ADCתжϣжϷжȡתֵ

    ADC_SoftwareStartConvCmd(ADC1, ENABLE);  //ûвⲿʹADCת
	
}

//===========================================================
//Funtion name  Adc_Isr_Get_Fun
//parameters
//returned value
//  ADCж  ÿжϵȡ
// 
//===========================================================
void Adc_Isr_Get_Fun()
{

	WORK.Test_Adc_Data_Rank[ WORK.Test_Adc_Data_Step ] = ADC_GetConversionValue(ADC1);  //ȡADCתֵ
	WORK.Test_Adc_Data_Step++;
	ADC_ClearITPendingBit(ADC1,ADC_IT_EOC);
	 
	if( WORK.Test_Adc_Data_Step == 1 )
	{
		ADC_RegularChannelConfig(ADC1, ADC_Channel_6, 1,ADC_SampleTime_55Cycles5); // ADCͨת˳Ͳʱ

		ADC_ITConfig(ADC1, ADC_IT_EOC, ENABLE);  //ADCתжϣжϷжȡתֵ

		ADC_SoftwareStartConvCmd(ADC1, ENABLE);  //ûвⲿʹADCת
		
	}
	else if( WORK.Test_Adc_Data_Step == 2 )
	{
		ADC_RegularChannelConfig(ADC1, ADC_Channel_6, 1,ADC_SampleTime_55Cycles5); // ADCͨת˳Ͳʱ

		ADC_ITConfig(ADC1, ADC_IT_EOC, ENABLE);  //ADCתжϣжϷжȡתֵ

		ADC_SoftwareStartConvCmd(ADC1, ENABLE);  //ûвⲿʹADCת	
	
	}	
	else if( WORK.Test_Adc_Data_Step == 3 )
	{
		ADC_RegularChannelConfig(ADC1, ADC_Channel_7, 1,ADC_SampleTime_55Cycles5); // ADCͨת˳Ͳʱ

		ADC_ITConfig(ADC1, ADC_IT_EOC, ENABLE);  //ADCתжϣжϷжȡתֵ

		ADC_SoftwareStartConvCmd(ADC1, ENABLE);  //ûвⲿʹADCת	
	
	}
	else if( WORK.Test_Adc_Data_Step == 4 )
	{
		ADC_RegularChannelConfig(ADC1, ADC_Channel_7, 1,ADC_SampleTime_55Cycles5); // ADCͨת˳Ͳʱ

		ADC_ITConfig(ADC1, ADC_IT_EOC, ENABLE);  //ADCתжϣжϷжȡתֵ

		ADC_SoftwareStartConvCmd(ADC1, ENABLE);  //ûвⲿʹADCת	
	
	}
	else if( WORK.Test_Adc_Data_Step == 5 )
	{
		ADC_RegularChannelConfig(ADC1, ADC_Channel_9, 1,ADC_SampleTime_55Cycles5); // ADCͨת˳Ͳʱ

		ADC_ITConfig(ADC1, ADC_IT_EOC, ENABLE);  //ADCתжϣжϷжȡתֵ

		ADC_SoftwareStartConvCmd(ADC1, ENABLE);  //ûвⲿʹADCת	
	
	}
	else
	{
		
		ADC_ITConfig(ADC1, ADC_IT_EOC, DISABLE);
		
		
		// WORK.Test_Adc_Buff_Cnt++;
		// if( WORK.Test_Adc_Buff_Cnt >= 20 )
		// {
			WORK.Test_Adc_Buff_Cnt = 0;
			
			// ѹ ֵ 
			WORK.Test_Adc_Data_Sum =  WORK.Test_Adc_Data_Rank[ 1 ] + WORK.Test_Adc_Data_Rank[ 2 ];
			WORK.Test_Adc_Data_Disp_Rank[ 0 ] = WORK.Test_Adc_Data_Sum >> 1;
			
			//  ֵ 
			WORK.Test_Adc_Data_Sum = WORK.Test_Adc_Data_Rank[ 3 ] + WORK.Test_Adc_Data_Rank[ 4 ];
			WORK.Test_Adc_Data_Disp_Rank[ 1 ] = WORK.Test_Adc_Data_Sum >> 1;

			// ntc ﲻ˲
			WORK.Test_Adc_Data_Sum = WORK.Test_Adc_Data_Rank[ 5 ];
			WORK.Test_Adc_Data_Disp_Rank[ 2 ] = WORK.Test_Adc_Data_Sum;			
			
			// WORK.Test_Adc_Data_Disp_Rank[ 1 ] = WORK.Test_Adc_Data_Rank[ 1 ];
			// WORK.Test_Adc_Data_Disp_Rank[ 2 ] = WORK.Test_Adc_Data_Rank[ 2 ];
		// }
		
		//GPIO_ResetBits( GPIOB , GPIO_Pin_13 );
	}
	
	
}
