//===============================================================================
//	FMD64F0A5
// â΢ 
// ROM        -        10k  -  14Bit 
// RAM        -          1k   -   8Bit
// EEPROM  -  128byte  -   8Bit 
// HIRC		  - 16MHZ
// 1T/2T/4T/
// 
//	汾עͣ 
// 	IICģʽ 
//  øһӲIIC
//	
//
//	
//===============================================================================


#include  "function_screen.h"
#include  "function_project.h"
#include  "function_ssd1306.h"
#include  "function_oz9350.h"


struct OLED_SCREEN			 SCREEN;


//******************************************************************************************************************
// name       :   ݳʼ  -  
// function   :    
//				  
//				   	
// definition : 	
//******************************************************************************************************************
void Oled_Init()
{
	
	SCREEN.Status = SCREEN_STATUS_INIT;
	
	SCREEN.Time_Unit_10ms = 0;
	
	SCREEN.Work_Sw = 0;


}

//******************************************************************************************************************
// name       :    
// function   :    
//				  
//				   	
// definition : 	
//******************************************************************************************************************
void Oled_Open_Set()
{
	
	SCREEN.Status = SCREEN_STATUS_INIT;
	
	SCREEN.Time_Unit_10ms = 0;
	
	SCREEN.Work_Sw = 1;
	
	SCREEN.Page_End_Message = 0;	

	SCREEN.Sub_Step_Time = 0;

}


//******************************************************************************************************************
// name       :    з״̬  
// function   :    1oled ʼ
//				  2: oled ҳ -    ڣ1׶  2л״̬ ʾ
//				  3: oled ʾ 	
// definition : 	
//******************************************************************************************************************
void Oled_Disp_Process()
{

		if( SCREEN.Time_Unit_10ms )
		{
			SCREEN.Time_Unit_10ms = 0;

			SCREEN.Sub_Step_Time++;
			
			SCREEN.Run_Time_10ms++;

			if( SCREEN.Run_Time_10ms >= 100 )
			{
				SCREEN.Run_Time_10ms = 0;
				SCREEN.Run_Time_1s++;
				if( SCREEN.Run_Time_1s >= 200 ) SCREEN.Run_Time_1s = 0;
			}

			if( SCREEN.Status == SCREEN_STATUS_INIT )
			{
				if( SCREEN.Work_Sw )
				{
					// ʼ  -   
					if( SCREEN.Sub_Step_Time > 40 )
					{
						SCREEN.Sub_Step_Time = 0;
						Oled_Process_Init();
						Oled_Page_Turn( SCREEN_OPEN_PAGE );
					}
	
				}
			}
			else if( SCREEN.Status == SCREEN_OPEN_PAGE )
			{
				// ҳǷ
				if( SCREEN.Page_Clr )
				{
					SCREEN.Page_Clr = 0;
					Oled_Disp_Clr();
					Oled_Page_Turn( SCREEN_PAGE_A );
				}
				else
				{
					Oled_Open_Screen();
				}
			}
			else if( SCREEN.Status == SCREEN_CLOSE_PAGE )
			{
				// ҳǷ
				if( SCREEN.Page_Clr )
				{
					SCREEN.Page_Clr = 0;
					Oled_Disp_Clr();
				}
				else
				{
					Oled_Close_Screen();
				}
			}
			else if( SCREEN.Status == SCREEN_PAGE_A )
			{
				// ҳǷ
				if( SCREEN.Page_Clr )
				{
					SCREEN.Page_Clr = 0;
					Oled_Disp_Clr();
				}
				else
				{
					Oled_Page_A_Screen();
				}
		
			}
			else if( SCREEN.Status == SCREEN_PAGE_B )
			{
				// ҳǷ
				if( SCREEN.Page_Clr )
				{
					SCREEN.Page_Clr = 0;
					Oled_Disp_Clr();
				}
				else
				{
					Oled_Page_B_Screen();
				}
			}
		}
}

//******************************************************************************************************************
// name       :  Oled_Page_Turn  
// function   :  ҳл 			   	
// definition : 	
//******************************************************************************************************************
void Oled_Page_Turn( unsigned char Page_Select )
{
	switch( Page_Select )
	{
		case SCREEN_OPEN_PAGE:
			
			SCREEN.Status   		= SCREEN_OPEN_PAGE;
			SCREEN.Page_Init 		= 0;

			SCREEN.Page_End_Message = 0;
			SCREEN.Sub_Step         = 0;

			
			SCREEN_CLR_ONCE;
			break;
			

			
		case SCREEN_CLOSE_PAGE:
		
			SCREEN.Status   		= SCREEN_CLOSE_PAGE;
			SCREEN.Page_Init 		= 0;

			SCREEN.Page_End_Message = 0;
			SCREEN.Sub_Step         = 0;	
			
			SCREEN_CLR_ONCE;
			
			break;
			
		case SCREEN_PAGE_A:
		
			SCREEN.Status   		 = SCREEN_PAGE_A;
			SCREEN.Page_Init 		 = 0;		
			SCREEN.Sub_Step          = 0;
			SCREEN_CLR_ONCE;
			
			break;
			
		case SCREEN_PAGE_B:
		
			SCREEN.Status    		= SCREEN_PAGE_B;
			SCREEN.Page_Init 		= 0;		
			SCREEN.Sub_Step         = 0;
			SCREEN_CLR_ONCE;
			
			break;
		
			
		default:break;
	}
}

//******************************************************************************************************************
// name       :    Oled_Open_Screen
// function   :    ҳ 1 -    0  			   	
// definition : 	
//******************************************************************************************************************
void Oled_Open_Screen( )
{
	switch( SCREEN.Sub_Step )
	{
		case 0:
			
			if( SCREEN.Sub_Step_Time >= 15 )
			{
				SCREEN.Sub_Step_Time = 0;
		
				Oled_P6x8str( X_6, Y_2, "4S1P BMS" );
		
				SCREEN.Sub_Step++;
			
			}
			
			break;
			
		case 1:
			
			if( SCREEN.Sub_Step_Time >= 30 )
			{
				SCREEN.Sub_Step_Time = 0;
			
				Oled_P6x8str( X_8, Y_3, "V0.1" );
				
				SCREEN.Sub_Step++;		
			}
			
			break;	

		case 2:
			 
			if( SCREEN.Sub_Step_Time >= 40 )
			{
				SCREEN.Sub_Step_Time = 0;
				
				
				SCREEN.Page_End_Message = 1;
			}
			
			break;				
			
		default:break;
	}
	
}


//******************************************************************************************************************
// name       :    Oled_Open_Screen
// function   :    ҳ 1 -    0  			   	
// definition : 	
//******************************************************************************************************************
void Oled_Close_Screen( )
{
	if( SCREEN.Page_Clr )
	{
		SCREEN.Page_Clr = 0;
		Oled_Disp_Clr();
	}
	else
	{
		switch( SCREEN.Sub_Step )
		{
			case 0:
				
				if( SCREEN.Sub_Step_Time >= 10 )
				{
					SCREEN.Sub_Step_Time = 0;
					
					Oled_P6x8str( X_6, Y_2, "BYE BYE" );
					
					SCREEN.Sub_Step++;
				}
				
				
				break;
				
			case 1:
				
				if( SCREEN.Sub_Step_Time >= 3 )
				{
					SCREEN.Sub_Step_Time = 0;
			
					SCREEN.Sub_Step++;
				}
				
				break;			
				
			case 2:
			
				// ʾ
				if( SCREEN.Sub_Step_Time >= 20 )
				{
					SCREEN.Sub_Step_Time = 0;

					SCREEN.Page_End_Message = 1;
				}
				
				break;
						
				
			default:break;
		}
	}
}


//******************************************************************************************************************
// name       :    Oled_Open_Screen
// function   :    ҳ 1 -    0  			   	
// definition : 	
//******************************************************************************************************************
void Oled_Page_A_Screen( )
{
	if( SCREEN.Page_Clr )
	{
		SCREEN.Page_Clr = 0;
		Oled_Disp_Clr();
	}
	else
	{
		switch( SCREEN.Sub_Step )
		{
			case 0:
				
				if( SCREEN.Sub_Step_Time >= 10 )
				{
					SCREEN.Sub_Step_Time = 8;
					
					if( SCREEN.Page_Init )
					{
					
						Oled_Disp_6x8_Numner( X_1, Y_1, SCREEN.Run_Time_1s, 3 );
					}
					else	// ʼʾ
					{
						// Oled_P6x8str( X_1, Y_1, "TIME:" );
						
					
					}
						
					SCREEN.Sub_Step++;
				}
				break;
				
			case 1:
				
				if( SCREEN.Sub_Step_Time >= 10 )
				{
					SCREEN.Sub_Step_Time = 0;
					
					if( SCREEN.Page_Init )
					{
							// if( GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_4 ) )
							// {
								// Oled_P6x8str( X_11, Y_1, "hight" );
							// }
							// else
							// {
								// Oled_P6x8str( X_11, Y_1, "low  " );
							// }
						
						
						Oled_Disp_6x8_Numner( X_11, Y_1, OZ9350.Register_Get_Mess[ 0 ], 3 );
						Oled_Disp_6x8_Numner( X_11, Y_2, OZ9350.Register_Get_Crc[ 0 ], 3 );
						Oled_Disp_6x8_Numner( X_11, Y_3, OZ9350.Register_Caculat_Crc[ 0 ], 3 );
						// Oled_Disp_6x8_Numner( X_5, Y_4, WORK.Test_Adc_Data_Rank_A[ 3 ], 4 );
						
						
	
					}
					else	// ʼʾ
					{
						Oled_P6x8str( X_5, Y_1, "Get_d" );
						Oled_P6x8str( X_5, Y_2, "Get_c" );
						Oled_P6x8str( X_5, Y_3, "Cac_c" );
					}
					
					SCREEN.Sub_Step++;
				}
				break;
				
				
			case 2:
				
				if( SCREEN.Sub_Step_Time >= 10 )
				{
					SCREEN.Sub_Step_Time = 0;
					
					if( SCREEN.Page_Init )
					{
						// Oled_Disp_6x8_Numner( X_10, Y_2, WORK.Test_Adc_Data_Rank_B[ 0 ], 4 );
						// Oled_Disp_6x8_Numner( X_10, Y_3, WORK.Test_Adc_Data_Rank_B[ 1 ], 4 );
						// Oled_Disp_6x8_Numner( X_10, Y_4, WORK.Test_Adc_Data_Rank_B[ 2 ], 4 );
						// Oled_Disp_6x8_Numner( X_10, Y_4, WORK.Test_Adc_Data_Rank_B[ 3 ], 4 );	
						
					}
					else	// ʼʾ
					{
						// Oled_P6x8str( X_10, Y_1, "CUR" );
			
					}
					
					SCREEN.Sub_Step++;
				}
				break;				
				
			case 3:
				
				if( SCREEN.Sub_Step_Time >= 10 )
				{
					SCREEN.Sub_Step_Time = 0;
					
					if( SCREEN.Page_Init )
					{
						// Oled_Disp_6x8_Numner( X_15, Y_2, WORK.Test_Adc_Data_Rank_C[ 0 ], 4 );
						// Oled_Disp_6x8_Numner( X_15, Y_3, WORK.Test_Adc_Data_Rank_C[ 1 ], 4 );
						// Oled_Disp_6x8_Numner( X_15, Y_4, WORK.Test_Adc_Data_Rank_C[ 2 ], 4 );
						// Oled_Disp_6x8_Numner( X_15, Y_4, WORK.Test_Adc_Data_Rank_C[ 3 ], 4 );	
					}
					else	// ʼʾ
					{
						// Oled_P6x8str( X_15, Y_1, "NTC" );
						SCREEN.Page_Init = 1;
					}
					
					SCREEN.Sub_Step = 0;
				}
				break;				
				
			default:break;
		}
	}
}


//******************************************************************************************************************
// name       :    Oled_Open_Screen
// function   :    ҳ 1 -    0  			   	
// definition : 	
//******************************************************************************************************************
void Oled_Page_B_Screen( )
{

	switch( SCREEN.Sub_Step )
	{
		case 0:
			// 
			if( SCREEN.Sub_Step_Time >= 10 )
			{
				SCREEN.Sub_Step_Time = 0;
		
				SCREEN.Sub_Step++;
				
			}
			
			
			break;
			
		case 1:
		
			// ʾ
			if( SCREEN.Sub_Step_Time >= 10 )
			{
				SCREEN.Sub_Step_Time = 5;

				SCREEN.Sub_Step++;
				
			}
			
			break;
			
		case 2:
			// ʾ汾
			if( SCREEN.Sub_Step_Time >= 10 )
			{
				SCREEN.Sub_Step_Time = 0;
	
				
				SCREEN.Sub_Step++;

			}
			
			break;	

		case 3:
			// 
			if( SCREEN.Sub_Step_Time >= 2 )
			{
				SCREEN.Sub_Step_Time = 0;
				

				
				SCREEN.Sub_Step++;
			}
			
			break;	

		case 4:
			// 
			if( SCREEN.Sub_Step_Time >= 2 )
			{
				SCREEN.Sub_Step_Time = 0;
				

			}
			
			break;	

		case 5:
			// ȴһ   
			if( SCREEN.Sub_Step_Time >= 40 )
			{
				SCREEN.Sub_Step_Time = 0;
				
				SCREEN.Page_End_Message = 1;
			}
			
			break;			
			
		default:break;
	}
}



//******************************************************************************************************************
// name       :    Oled_Time_Add
// function   :    λʱ 		   	
// definition : 	
//******************************************************************************************************************
void Oled_Time_Add()
{
	SCREEN.Time_Unit_10ms = 1;
}



