


/*****************************************************************************************
*  ͷļ - 
*****************************************************************************************/


#ifndef	_function_screen_H
#define	_function_screen_H

#include "ch32v10x.h"

/*****************************************************************************************
*     
*****************************************************************************************/


//========   ҳ ״̬ 
#define SCREEN_STATUS_INIT				0		
#define SCREEN_OPEN_PAGE				1
#define SCREEN_CLOSE_PAGE				2
#define SCREEN_PAGE_A					3
#define SCREEN_PAGE_B					4
#define SCREEN_PAGE_C					5
#define SCREEN_PAGE_D					6
#define SCREEN_PAGE_E					7
#define SCREEN_PAGE_F					8
#define SCREEN_PAGE_G					9


#define SCREEN_CLR_ONCE					SCREEN.Page_Clr = 1 



struct OLED_SCREEN																																			
{
	unsigned char Work_Sw;
	
	unsigned char Status;
	unsigned char Time_Unit_10ms;
	
	unsigned char Sub_Step;
	unsigned char Sub_Step_Time;
	unsigned char Sub_Step_Max;
	
	unsigned int  Data_Disp[10];
	unsigned int  Data_Disp_Bak[10];
	
	unsigned char Page_Init;
	unsigned char Page_End_Message;

	unsigned char Page_Clr;
	
		
	unsigned char Run_Time_10ms;
	unsigned char Run_Time_1s;

};
extern struct OLED_SCREEN SCREEN;


void Oled_Init();
void Oled_Open_Set();
void Oled_Time_Add();
void Oled_Page_Turn( unsigned char Page_Select );
void Oled_Disp_Process();

void Oled_Open_Screen();
void Oled_Close_Screen();
void Oled_Page_A_Screen();
void Oled_Page_B_Screen();

#endif	
