/**************************************************************************//**

 * 
 ******************************************************************************/
#include "ch32v10x.h"


#ifndef _function_ssd1306_H__
#define _function_ssd1306_H__

	#define OLED_SET				OLED_12832_SET	
	#define	OLED_12864_SEL			0	
	#define OLED_12832_SET			1
	
	#define OLED_LERI_SEL			OLED_LEFT_RIGHT_TURN
	#define OLED_LEFT_RIGHT_NORM	0
	#define OLED_LEFT_RIGHT_TURN	1
	
	#define OLED_UPDO_SEL			OLED_UP_DOWN_TURN
	#define OLED_UP_DOWN_NORM		0
	#define OLED_UP_DOWN_TURN		1

	#define OLED_SDA_HIGHT 						GPIO_SetBits(  GPIOA , GPIO_Pin_9  )
	#define OLED_SDA_LOW 						GPIO_ResetBits( GPIOA , GPIO_Pin_9 )	
	
	#define OLED_SCK_HIGHT 						GPIO_SetBits(  GPIOA , GPIO_Pin_10  )	
	#define OLED_SCK_LOW 						GPIO_ResetBits( GPIOA , GPIO_Pin_10 )	


	//******************************************************************************************
	// name       :  궨       
	// function   :  
	// definition : 
	//******************************************************************************************
	//    
	#define X_WIDTH 		128
	#define Y_WIDTH 		64
	#define	Brightness		5

	// 궨  дλ 
	#define X_1			1
	#define X_2			1*6+1
	#define X_3			2*6+1
	#define X_4			3*6+1
	#define X_5			4*6+1
	#define X_6			5*6+1
	#define X_7			6*6+1
	#define X_8			7*6+1
	#define X_9			8*6+1
	#define X_10		9*6+1
	#define X_11		10*6+1
	#define X_12		11*6+1
	#define X_13		12*6+1
	#define X_14		13*6+1
	#define X_15		14*6+1
	#define X_16		15*6+1
	#define X_17		16*6+1
	#define X_18		17*6+1
	#define X_19		18*6+1
	#define X_20		19*6+1
	#define X_21		20*6+1

	#define Y_1			0
	#define Y_2			1
	#define Y_3			2
	#define Y_4			3
	#define Y_5			4
	#define Y_6			5
	#define Y_7			6
	#define Y_8			7

	#define DELAY_TIME_LONG		10
	#define DELAY_TIME_MID		10
	#define DELAY_TIME_SHORT	5		

	#define SCMD	0
	#define SDATA	1


		
	
	//******************************************************************************************
	// name       :  ⲿõĺ          
	// function   :  
	// definition : 
	//******************************************************************************************
	void Oled_I2c_Start();
	void Oled_I2c_End();
	void Oled_I2c_Delay(unsigned char time);
	void Oled_I2c_Skip_Ack();
	void Oled_I2c_Sen_Byte(unsigned char byte);
	void Oled_Set_Pos(unsigned char x, unsigned char y);
	void Oled_Wr_Btye( unsigned char byte, unsigned char mode );
	void Oled_Disp_Close();
	void Oled_Disp_Open();
	void Oled_Disp_Clr();
	void Oled_Process_Init();

	void Oled_P6x8str(unsigned char x, unsigned char y,unsigned char *str );
	void Oled_P6x8str_Black(unsigned char x, unsigned char y,unsigned char *str );

	void Oled_Disp_6x8_Numner(unsigned char x_adr,unsigned char y_adr,unsigned int disp_number,unsigned char disp_len);
	void Oled_Disp_6x8_Numner_Black( unsigned char x_adr, unsigned char y_adr, unsigned int disp_number, unsigned char disp_len );
	void Oled_P6x8num_Point(unsigned char x_adr,unsigned char y_adr,unsigned int disp_number,unsigned char front_len,unsigned char next_len);
	
	
#endif  
